//+------------------------------------------------------------------+
//|                                            SwapFinder_script.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Bogdan Caramalac"
#property link      "mailto:fxeconomist@yahoo.com"


extern int MarginUsage=75;
extern int MaxCurrenciesUsed=0;
extern bool JustTesting=True;
extern int Slippage=3;

#include <bclib.mq4>
#include <WinUser32.mqh>

//feel free to add more currencies to be tested...
string TestCurrencies[13]={"EUR","USD","GBP","JPY",
                           "CHF","AUD","CAD","NZD",
                           "HKD","NOK","SEK","PLN",
                           "RON"};

//increase this one's dimension to make more currencies usable...
//however, this will slow down the process
string UsableCurrencies[16];
int CurrenciesNo=0;
bool FatalError=false;
bool FilterLotsToDot1=True;
int TickDenominator=1;
string Appendix="";



//**************************************************************************************


int CurrencyPos(string currency)
    {
    int i,res;
    res=-1;
    if (CurrenciesNo==0)
       return(res);
    for (i=0;i<CurrenciesNo;i++)
       {
       if (UsableCurrencies[i]==currency)
          {
          res=i;
          return(res);
          }
       }
    return(res);
    }


void GetCurrencies()
  {
  int i,j,ars,p1,p2;
  string ctr;
  ars=ArraySize(TestCurrencies);
  for (i=0;i<ars;i++)
     {
     for (j=0;j<ars;j++)
        {
        if (i==j)
           continue;
        else
           {
           ctr=StringConcatenate(TestCurrencies[i],TestCurrencies[j],Appendix);
           if (ContractIsTraded(ctr)==True)
              {
              p1=CurrencyPos(TestCurrencies[i]);
              p2=CurrencyPos(TestCurrencies[j]);
              if (p1==-1)
                 {
                 UsableCurrencies[CurrenciesNo]=TestCurrencies[i];
                 CurrenciesNo=CurrenciesNo+1;
                 }
              if (p2==-1)
                 {
                 UsableCurrencies[CurrenciesNo]=TestCurrencies[j];
                 CurrenciesNo=CurrenciesNo+1;
                 }                 
              }//if (ContractIsTraded(ctr)==True)
           }//else if (i==j)
        }//for (j=0;j<ars;j++)
     }//for (i=0;i<ars;i++)         
  return;
  }

double MedPrice(string contract)
  {
  double res;
  res=(MarketInfo(contract,MODE_BID)+MarketInfo(contract,MODE_ASK))/2;
  return(res);
  }

double GetCurrency(string crrcy,string incrrcy)
  {
  double CurrencyValues[16];
  string majors,actcrrcy,crtmajor,crrhere,ctr;
  int count=0;
  int i,j,p,pass;
  double res;
  actcrrcy=AccountCurrency();
  for (i=0;i<16;i++)
      CurrencyValues[i]=0;
  CurrencyValues[CurrencyPos(actcrrcy)]=1;  
  count=count+1;
  majors="USD EUR GBP JPY";
  for (i=1;i<5;i++)
     {
     crtmajor=StringSubstr(majors,i*4-4,3);
     p=CurrencyPos(crtmajor);
     ctr=StringConcatenate(crtmajor,actcrrcy,Appendix);
     if (ContractIsTraded(ctr)==true)
        {
        CurrencyValues[p]=MedPrice(ctr);
        count=count+1;
        }
     else
        {
        ctr=StringConcatenate(actcrrcy,crtmajor,Appendix);
        if (ContractIsTraded(ctr)==true)
          {
          CurrencyValues[p]=1/MedPrice(ctr);
          count=count+1;
          }
        }//else if (ContractIsTraded(ctr)==true)
     }//for (i=1;i<5;i++)
  
  for (pass=0;pass<CurrenciesNo+1;pass++)
     {
     for (i=0;i<CurrenciesNo;i++)
        {
        if (CurrencyValues[i]==0)//do block if current currency has no value
           {
           crrhere=UsableCurrencies[i];           
           for (j=0;j<CurrenciesNo;j++)
              {
              if (CurrencyValues[j]!=0)//don't bother if currency against which we test hasn't been assigned a value yet
                 {
                 ctr=StringConcatenate(crrhere,UsableCurrencies[j],Appendix);
                 if (ContractIsTraded(ctr)==true)
                    {
                    CurrencyValues[i]=MedPrice(ctr)*CurrencyValues[j];
                    count=count+1;
                    }
                 else
                    {                    
                    ctr=StringConcatenate(UsableCurrencies[j],crrhere,Appendix);
                    if (ContractIsTraded(ctr)==true)
                       {
                       CurrencyValues[i]=(1/MedPrice(ctr))*CurrencyValues[j];
                       count=count+1;
                       }
                    }
                 if (CurrencyValues[i]!=0)//already assigned, jump out;
                    break;
                 }//if (CurrencyValues[j]!=0)
              }//for (j=0;j<CurrencyNo;j++)
           }//if (CurrencyValues[i]==0)        
        }//for (i=0;i<CurrencyNo;i++)  
     if (count==CurrenciesNo) 
        break;
    }//for (pass=0;pass<CurrencyNo+1;pass++)        
  res=(CurrencyValues[CurrencyPos(crrcy)])/CurrencyValues[CurrencyPos(incrrcy)];
  return(res);
  }


//********************************************************************

//********************************************************************

bool IsConfigValid(string BinConfig,int Permutation,int &Loaded,string &contracts[16],int &ops[16])
  {
 bool res=false;
  int i;
  int perm[16];
  bool cex1,cex2;
  int Asc1=49;
  string ctest1,ctest2;  
  string LoadedCrrcies[16];
  string permcrrcies[16];
  for (i=0;i<16;i++)
     {
     perm[i]=0;
     permcrrcies[i]="";
     LoadedCrrcies[i]="";
     ops[i]=0;
     contracts[i]="";
     }
  Loaded=0;
  for (i=0;i<StringLen(BinConfig);i++)
     {
     if (StringGetChar(BinConfig,i)==Asc1)
        {
        LoadedCrrcies[Loaded]=UsableCurrencies[i];
        Loaded=Loaded+1;
        }     
     }
  if (Loaded<3)
     return(res);
  GenPermutation(Permutation,Loaded,perm);
  for (i=0;i<Loaded;i++)
     {
     permcrrcies[i]=LoadedCrrcies[perm[i]-1];
     }
  res=True;
  for (i=0;i<Loaded;i++)
     {
     if (i==Loaded-1)
        {
        //supposing continuous sell...from the first currency, to the first again
        //if a contract does not exist, it will be reversed and bought
        ctest1=StringConcatenate(permcrrcies[i],permcrrcies[0],Appendix);
        ctest2=StringConcatenate(permcrrcies[0],permcrrcies[i],Appendix);        
        cex1=ContractIsTraded(ctest1);
        cex2=ContractIsTraded(ctest2);
        if (cex1==False&&cex2==False)
           {
           res=false;
           return(res);
           }
        if (cex1==True)
           {
           ops[i]=OP_SELL;
           contracts[i]=ctest1;
           }
        else
           {
           ops[i]=OP_BUY;          
           contracts[i]=ctest2;
           }
        }
     else
        {
        //supposing continuous sell...from the first currency, to the first again
        //if a contract does not exist, it will be reversed and bought
        ctest1=StringConcatenate(permcrrcies[i],permcrrcies[i+1],Appendix);
        ctest2=StringConcatenate(permcrrcies[i+1],permcrrcies[i],Appendix);
        cex1=ContractIsTraded(ctest1);
        cex2=ContractIsTraded(ctest2);
        if (cex1==False&&cex2==False)
           {
           res=false;
           return(res);
           }
        if (cex1==True)
           {
           ops[i]=OP_SELL;           
           contracts[i]=ctest1;
           }
        else
           {
           ops[i]=OP_BUY;           
           contracts[i]=ctest2;
           }
        }
     }//for (i=0;i<Loaded;i++)
  return(res);                        
  }

void EstablishSwaps(int CrrNo,string contracts[],int ops[],double volumes[],double &usage[],double &TotalUsed,double &Swaps[],double &Interests[],double &NormalROA[],double &WeightedROA[],double &ROA, double &ROE)
  {
  int i;
  string crr1;
  TotalUsed=0;
  for (i=0;i<CrrNo;i++)
     {
     crr1=StringSubstr(contracts[i],0,3);
     usage[i]=volumes[i]*GetCurrency(crr1,AccountCurrency());
     TotalUsed=TotalUsed+usage[i];
     }
  for (i=0;i<CrrNo;i++)
     {   
     crr1=StringSubstr(contracts[i],0,3);      
     if (AccountCompany()=="Interbank FX, LLC")
       {
       if (ops[i]==OP_BUY) 
          {
          Swaps[i]=MarketInfo(contracts[i],MODE_SWAPLONG);
          Interests[i]=(volumes[i]*Swaps[i])/10000;
          NormalROA[i]=((Interests[i]/usage[i])*100)*365;
          WeightedROA[i]=NormalROA[i]*usage[i]/TotalUsed;
          ROA=ROA+WeightedROA[i];
          }
       else
          {
          Swaps[i]=MarketInfo(contracts[i],MODE_SWAPSHORT);
          Interests[i]=(volumes[i]*Swaps[i])/10000;
          NormalROA[i]=((Interests[i]/usage[i])*100)*365;
          WeightedROA[i]=NormalROA[i]*usage[i]/TotalUsed;
          ROA=ROA+WeightedROA[i];
          }
          continue;
       }          
    if (AccountCompany()=="FXDirectDealer")
       {
       if (ops[i]==OP_BUY) 
          {
          Swaps[i]=MarketInfo(contracts[i],MODE_SWAPLONG);
          Interests[i]=(volumes[i]*Swaps[i])/100000;
          NormalROA[i]=((Interests[i]/usage[i])*100)*365;
          WeightedROA[i]=NormalROA[i]*usage[i]/TotalUsed;          
          ROA=ROA+WeightedROA[i];
          }
       else
          {
          Swaps[i]=MarketInfo(contracts[i],MODE_SWAPSHORT);
          Interests[i]=(volumes[i]*Swaps[i])/100000;
          NormalROA[i]=((Interests[i]/usage[i])*100)*365;
          WeightedROA[i]=NormalROA[i]*usage[i]/TotalUsed;          
          ROA=ROA+WeightedROA[i];
          }
          continue;          
       }
    WriteLn("Broker "+AccountCompany()+" not programmed!");
    FatalError=True;    
    }
  ROE=ROA*TotalUsed/AccountEquity();
  }


  
void EstablishRing(int CrrNo,string contracts[],int ops[],double &volumes[],double &usage[],double &TotalUsed,
     double &Swaps[],double &Interests[],double &NormalROA[],double &WeightedROA[],double &ROA, double &ROE, 
     double &FXResult, double &FinalROE)
  {
  string ctest1;
  int ms;
  bool cex1;
  int i;
  int available;
  if (JustTesting==false)
     available=Truncate(AccountFreeMargin()*AccountLeverage()*(MarginUsage/100.00));
  else
     available=Truncate(AccountEquity()*AccountLeverage()*(MarginUsage/100.00));  
  //WriteLn("Available = "+DoubleToStr(available,0));
  int q=available/CrrNo;
  string crr1,crr2; 
  double got,units,vol_small,vol_big;
  double mk,Interest;
  string rev;
  string ResultCrrcy;  
  int operation;  
  for (i=0;i<CrrNo;i++)
     {
     crr1=StringSubstr(contracts[i],0,3);
     crr2=StringSubstr(contracts[i],3,3);          
     if (i==0)
        {
        volumes[i]=0;
        mk=GetCurrency(AccountCurrency(),crr1);                
        units=q*mk;
        vol_small=Truncate( units/1000 ) * 1000;
        vol_big=Truncate( (units+1000)/1000 ) * 1000;        
        if ((units-vol_small)<=(vol_big-units)&&vol_small>0)
           volumes[i]=vol_small;
        else
           {
           if (vol_small==0||((vol_big-units<=units-vol_small)&&vol_big>0) )
              volumes[i]=vol_big;
           }
        rev="";
        
        if (ops[i]==OP_SELL)
            {
            got=volumes[i]*MarketInfo(contracts[i],MODE_BID);
            ResultCrrcy=crr2;
            }
        else 
            {
            got=volumes[i];
            ResultCrrcy=crr1;        
            }
        }
     else
        {
        if (ResultCrrcy==crr1)//we have the 1st currency at entry, we have a SHORT
           {
	        units=got;
           vol_small=Truncate( units/1000 ) * 1000;
           vol_big=Truncate( (units+1000)/1000 )  * 1000;
           if ((units-vol_small)<=(vol_big-units)&&vol_small>0)
              volumes[i]=vol_small;
           else
              {
              if (vol_small==0||((vol_big-units<=units-vol_small)&&vol_big>0) )
                 volumes[i]=vol_big;
              }           
           rev="";
           ResultCrrcy=crr2;
           mk=MarketInfo(contracts[i],MODE_BID);
 	        got=mk*volumes[i];
           }
        else//we have a LONG
           {
           mk=MarketInfo(contracts[i],MODE_ASK);           
           units=got*(1/mk);
           rev="reversed";
           vol_small=Truncate( units/1000 ) * 1000;
           vol_big=Truncate( (units+1000)/1000 ) * 1000;
           if ((units-vol_small)<=(vol_big-units)&&vol_small>0)
              volumes[i]=vol_small;
           else
              {              
              if (vol_small==0||((vol_big-units<=units-vol_small)&&vol_big>0) )
                 volumes[i]=vol_big;
              }     
           ResultCrrcy=crr1;                              
   	     got=volumes[i];
           }           
        }//else if (i==0)      
     //usage[i]=volumes[i]*GetCurrency(crr1,AccountCurrency());
     //TotalUsed=TotalUsed+usage[i];
        //WriteLn(StringConcatenate("Got ",DoubleToStr(got,4)," in ",ResultCrrcy," by applying rate ",DoubleToStr(mk,4)," of ",contracts[i]," ",rev));     
        //WriteLn(StringConcatenate("---------", OrderType2Str(ops[i])," ",DoubleToStr(volumes[i],0),"  ",contracts[i] ) );             
     }//for (i=0;i<CrrNo;i++)         
  ROA=0;
  ROE=0;
  FXResult=0;
  for (i=0;i<CrrNo;i++)
      {
      FXResult=FXResult-MarketInfo(contracts[i],MODE_SPREAD)*(MarketInfo(contracts[i],MODE_TICKVALUE)/TickDenominator)*volumes[i]/10000;
      }
  FXResult=(FXResult/AccountEquity())*100;
  EstablishSwaps(CrrNo,contracts,ops,volumes,usage,TotalUsed,Swaps,Interests,NormalROA,WeightedROA,ROA,ROE);
  FinalROE=ROE+FXResult;
  return;  
  }

bool CheckLotSizes(int ncrr,double volumes[])
  {
  int i;
  bool res=True;
  for (i=0;i<ncrr;i++)
     {
     if (NormalizeDouble(volumes[i]/1000*0.01,2)<0.1)
        {
        res=false;
        break;
        }
     }
  return (res);
  }
  

void GetBestRing(int maxcrrcies, int &bestconfig, int &permutation)
  {
  int icomb,maxperm,iperm;
  int best=-1;
  permutation=-1;
  double maximdbl=Truncate(MathPow(2,CurrenciesNo))-1;  
  double Usage[16];
  int maxim;
  string image;  
  string Contracts[16];
  int Ops[16];
  string combimg,permimg;
  double Volumes[16];
  bool valid;
  double ROA,ROE;
  double Swaps[16];
  double NormalROA[16];
  double WeightedROA[16];
  double Interests[16];
  double bestswap=-99999999;
  int crrcies,iimg;
  double TotalSwap,TotalUsed;
  double FXResult,FinalROE;
  maxim=MathRound(maximdbl);
  WriteLn(StringConcatenate("Maximal combination: ",DoubleToStr(maxim,0)));
  WriteLn("");
  for (icomb=maxim;icomb>=0;icomb--)
     {
     image=Padl(ConvertTo(2,icomb),CurrenciesNo,"0");
     crrcies=Occurs("1",image);
     valid=false; 
     if (crrcies>=3&&crrcies<=maxcrrcies)
        {         
        maxperm=Factorial(crrcies)-1;
        combimg="";
        for (iimg=0;iimg<CurrenciesNo;iimg++)
           {
           if (StringElement(image,iimg)=="1")
               combimg=StringConcatenate(combimg,UsableCurrencies[iimg]," ");
           }       
       WriteLn(StringConcatenate("Studying ",combimg," having ",DoubleToStr(maxperm+1,0)," permutations"));
       for (iperm=0;iperm<=maxperm;iperm++)
           {
           ROA=-1;
           ROE=-1;
           valid=IsConfigValid(image,iperm,crrcies,Contracts,Ops);
           if (valid==True)
              {
              EstablishRing(crrcies,Contracts,Ops,Volumes,Usage,TotalUsed,Swaps,Interests,NormalROA,WeightedROA,ROA,ROE,FXResult,FinalROE);
              if (FatalError==true)
                 return;
              if (FilterLotsToDot1==True)
                 valid=CheckLotSizes(crrcies,Volumes);
              if (valid==false)               
                 continue;
              WriteLn(StringConcatenate(" Found ring with ROA=",DoubleToStr(ROA,4),"%  ROE=",DoubleToStr(ROE,4),"%  FinalROE=",DoubleToStr(FinalROE,4),"%"));
              if (ROA>bestswap&&ROA>=0)
                 {
                 best=icomb;
                 permutation=iperm;
                 bestswap=ROA;
                 }//if (TotalSwap>=bestswap&&TotalSwap>=0)
              }//if (valid==True);
           }//for (iperm=0;iperm<=maxperm;iperm++)
       }//if (crrcies>=3)
      Say(2,StringConcatenate("Completed...",DoubleToStr(((maxim-icomb)/maxim)*100,2)));
     }//for (icomb=0;icomb<=maxim;icomb++)
     Say(2,"Done");
     WriteLn("Best has been chosen combination "+DoubleToStr(best,0));
     bestconfig=best;
  return;
  }
  
  
int GetMaxMagic()
  {
  int maxmagic=0;
  int ntrades=OrdersTotal();
  int i;
  int mhere=0;
  if (ntrades!=0)
     {
     for (i=0;i<ntrades;i++)
        {
        OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
        mhere=OrderMagicNumber();
        if (mhere>maxmagic)
           maxmagic=mhere;
        }
     }
  return(mhere);
  }
     
  
void TradeRing(int CrrNo,int Ops[],string Contracts[],double Volumes[],int Magic)
  {
  ClearSplash();
  int i,Gle;
  double price;
  string ErrType,ErrText,ErrExplanation;
  for (i=0;i<CrrNo;i++)
      {      
      if (Ops[i]==OP_BUY)
         price=MarketInfo(Contracts[i],MODE_ASK);
      else
         price=MarketInfo(Contracts[i],MODE_BID);
      SplashLn("Trying with "+Contracts[i]+" "+DoubleToStr( NormalizeDouble(Volumes[i]/1000*0.01,2) , 2)     ) ;
      OrderSend(Contracts[i],Ops[i],NormalizeDouble(Volumes[i]/1000*0.01,2),price,Slippage,0,0,"",Magic,0,Blue);      
      Gle=GetLastError();
      if (Gle!=0)
         {
     
         TranslateError(Gle,ErrType,ErrText,ErrExplanation);
         SplashLn(ErrType+CRLF()+ErrText+CRLF()+ErrExplanation);
         SplashScreen();
         }
      }
  }  
  
void AnalyseRing(int nRing)  
  {
  int crrcies=0;
  double Usage[16];
  string Contracts[16];
  int Ops[16];
  double Volumes[16];  
  double ROA,ROE;
  double Swaps[16];
  double NormalROA[16];
  double WeightedROA[16];
  double Interests[16];  
  double TotalUsed;
  int ntrades=OrdersTotal();
  int i,mhere;
  double op;
  op=0;              
  if (ntrades!=0)
    {
    for (i=0;i<ntrades;i++)
      {
       OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
       mhere=OrderMagicNumber();      
       if (mhere==nRing)
         {
          Contracts[crrcies]=OrderSymbol();
          Ops[crrcies]=OrderType();
          Volumes[crrcies]=OrderLots()/0.01*1000;
          crrcies=crrcies+1;
          op=op+OrderProfit();
         }
      }
    if (crrcies!=0)
      {      
      EstablishSwaps(crrcies,Contracts,Ops,Volumes,Usage,TotalUsed,Swaps,Interests,NormalROA,WeightedROA,ROA,ROE);
      DisplayRing("Currently traded ring ( having magic "+Alltrim(DoubleToStr(mhere,0))+" )",(op/AccountEquity())*100,crrcies,Contracts,Ops,Volumes,Usage,TotalUsed,Swaps,Interests,NormalROA,WeightedROA,ROA,ROE);
      }
    }
  return;
  }    
  
void DisplayRing(string title,double op,int crrcies,string Contracts[],int Ops[],double &Volumes[],double &Usage[],double &TotalUsed,double &Swaps[],double &Interests[],double &NormalROA[],double &WeightedROA[],double &ROA, double &ROE)
  {
   int iimg;
   ClearSplash();                     
   SplashLn(title);
   SplashLn("");
   SplashLn("Usage("+AccountCurrency()+")       %     Op.     Volume   Contract     Swap        Interest    NormalROA   WeightedROA");
   SplashLn("");
   for (iimg=0;iimg<crrcies;iimg++)     
       SplashLn( StringConcatenate(       
           Padl(DoubleToStr(Usage[iimg],2),10," "),"   ",
           Padl(DoubleToStr(Usage[iimg]/TotalUsed*100,4),8," "),"   ",
           OrderType2Str(Ops[iimg]),"   ",
           Padl(DoubleToStr(Volumes[iimg],2),10," "),"  ",
           Lower(Contracts[iimg]),"   ",
           Padl(DoubleToStr(Swaps[iimg],4),10," "),"  ",
           Padl(DoubleToStr(Interests[iimg],4),10," "),"     ",
           Padl(DoubleToStr(NormalROA[iimg],4),10," "),"         ",
           Padl(DoubleToStr(WeightedROA[iimg],4),10," ")                                
        ));       
   SplashLn("");
   SplashLn(DoubleToStr(TotalUsed,2));
   SplashLn("");
   SplashLn(" ROA = "+DoubleToStr(ROA,4)+"%");   
   SplashLn(" ROE = "+DoubleToStr(ROE,4)+"%");   
   if (op!=0)
      {
      SplashLn("");
      SplashLn("Forex result = "+DoubleToStr(op,4)+"%");
      SplashLn("");
      SplashLn("Final ROE = "+DoubleToStr(ROE+op,4)+"%");
      }
   SplashScreen();     
  }

void ScanRings(int maxcrrcies)
  {
   string Contracts[16];
   int Ops[16];  
   double Volumes[16];
   double Usage[16];
   string image;
   double ROA,ROE;
   double Swaps[16];
   double NormalROA[16];
   double WeightedROA[16];
   double Interests[16];
   double FXResult,FinalROE;
   bool valid;
   int mb;
   int gmm,icrt;
   double TotalUsed;
   int bestconfig,bestperm,crrcies,iimg,ms;
   GetBestRing(maxcrrcies,bestconfig,bestperm);
   if (FatalError==true)
      return;
   if (bestconfig!=-1)
     {
     image=Padl(ConvertTo(2,bestconfig),CurrenciesNo,"0");
     valid=IsConfigValid(image,bestperm,crrcies,Contracts,Ops);
     EstablishRing(crrcies,Contracts,Ops,Volumes,Usage,TotalUsed,Swaps,Interests,NormalROA,WeightedROA,ROA,ROE,FXResult,FinalROE);            
     DisplayRing("Best ring found ",FXResult,crrcies,Contracts,Ops,Volumes,Usage,TotalUsed,Swaps,Interests,NormalROA,WeightedROA,ROA,ROE);
     SplashLn("Combination = "+DoubleToStr(bestconfig,0) );
     SplashLn("Permutation ="+DoubleToStr(bestperm,0) );          
     }
   else
     {
     ClearSplash();
     SplashLn("Sorry, nothing found!");
     SplashScreen();
     ClearSplash();
     }    
     
   if (OrdersTotal()!=0||JustTesting==false)
      mb=SplashScreen();
   else
      {
      if (bestconfig!=-1)
        {
        SplashLn("");
        SplashLn("Trade ring ?");
        mb=SplashScreen(MB_YESNO);                       
        if (mb==IDYES)
          {
          TradeRing(crrcies,Ops,Contracts,Volumes,GetMaxMagic()+1);           
          }
        }
      }
   ClearSplash();
   gmm=GetMaxMagic();    
   if (gmm!=0)
     {   
     for (icrt=0;icrt<=gmm;icrt++)
         AnalyseRing(icrt);
     }   
  }
  


void SetBrokerPolicies()
  {
  if (AccountCompany()=="Interbank FX, LLC")
     {
     FilterLotsToDot1=False;
     TickDenominator=1;
     Appendix="m";
     return;
     }
  if (AccountCompany()=="FXDirectDealer")  
     {
     FilterLotsToDot1=True;
     TickDenominator=10;
     Appendix="";
     return;
     }
  WriteLn("Broker "+AccountCompany()+" not programmed!");
  FatalError=True;         
  }    
 
  

int init()
  {
  SetTextParameters("Courier New",10);
  ClearText();
  SetBrokerPolicies();
  int i;  
  GetCurrencies();  
  for (i=0;i<CurrenciesNo;i++)
      Write(UsableCurrencies[i]+"  ");      
  WriteLn("");
  WriteLn("");
  SetTextFirstScroll(3); 
  if ((JustTesting==false)&&(IsTradeAllowed()==false))
     {
     WriteLn("Script is set to trade, yet not allowed from setup window at startup!");
     return(1);
     }
  if (FatalError==true)
     return(1);
  return(0);
  }
  
    

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
  if (MaxCurrenciesUsed==0)
     ScanRings(CurrenciesNo);  
  else
     ScanRings(MaxCurrenciesUsed);     
  return(0);   
  }
//+------------------------------------------------------------------+